"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.migrator = void 0;
var qiita_1 = require("../qiita");
var TurndownService = require('turndown');
var got = require('got');
var parseUrl = require('url').parse;
var _a = require('hexo-fs'), exists = _a.exists, listDir = _a.listDir, readFile = _a.readFile;
var _b = require('hexo-util'), slugize = _b.slugize, unescapeHTML = _b.unescapeHTML;
var _c = require('path'), join = _c.join, parse = _c.parse;
var migrator = function (args) {
    return __awaiter(this, void 0, void 0, function () {
        var source, alias, redirect, addtag, skipduplicate, limit, _a, config, log, Post, untitledPostCounter, errNum, skipNum, rEntity, posts, currentPosts, feed, help, err_1, i, item, created_at, tags, url, body, title, untitledPostTitle, newPost, postFolder, folderExist, files, _b, _i, posts_1, post, err_2, postsNum;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    source = args._.shift();
                    alias = args.alias, redirect = args.redirect, addtag = args.addtag;
                    skipduplicate = Object.prototype.hasOwnProperty.call(args, 'skipduplicate');
                    limit = args.limit;
                    _a = this, config = _a.config, log = _a.log;
                    Post = this.post;
                    untitledPostCounter = 0;
                    errNum = 0;
                    skipNum = 0;
                    rEntity = /&#?\w{2,4};/;
                    posts = [];
                    currentPosts = [];
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 3, , 4]);
                    if (!source) {
                        help = [
                            'Usage: hexo migrate qiita <username> [--alias]',
                            '',
                            'For more help, you can check the docs: http://hexo.io/docs/migration.html'
                        ];
                        throw help.join('\n');
                    }
                    return [4 /*yield*/, (0, qiita_1.getQiitaJson)(source)];
                case 2:
                    feed = _c.sent();
                    log.info('Analyzing %s...', feed);
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _c.sent();
                    // @ts-ignore
                    throw new Error(err_1);
                case 4:
                    if (feed) {
                        if (typeof limit !== 'number' || limit > feed.length || limit <= 0)
                            limit = feed.length;
                        for (i = 0; i < limit; i++) {
                            item = feed[i];
                            created_at = item.created_at, tags = item.tags, url = item.url;
                            body = item.body, title = item.title;
                            if (!title) {
                                untitledPostCounter += 1;
                                untitledPostTitle = 'Untitled Post - ' + untitledPostCounter;
                                title = untitledPostTitle;
                                log.warn('Post found but without any titles. Using %s', untitledPostTitle);
                            }
                            else {
                                log.info('Post found: %s', title);
                            }
                            if (rEntity.test(title))
                                title = unescapeHTML(title);
                            if (title.includes('"') && (title.includes(':') || title.startsWith('#') || title.startsWith('!!')))
                                title = title.replace(/"/g, '\\"');
                            newPost = {
                                title: title,
                                date: created_at,
                                tags: __spreadArray(__spreadArray([], tags.map(function (t) { return t.name; }), true), (addtag ? ["qiita"] : []), true),
                                excerpt: body.slice(0, 100),
                                content: body,
                                alias: alias && url ? parseUrl(url).pathname : undefined,
                                redirect: redirect && url ? url : undefined
                            };
                            posts.push(newPost);
                        }
                    }
                    if (!skipduplicate) return [3 /*break*/, 9];
                    postFolder = join(config.source_dir, '_posts');
                    return [4 /*yield*/, exists(postFolder)];
                case 5:
                    folderExist = _c.sent();
                    if (!folderExist) return [3 /*break*/, 7];
                    return [4 /*yield*/, listDir(join(config.source_dir, '_posts'))];
                case 6:
                    _b = _c.sent();
                    return [3 /*break*/, 8];
                case 7:
                    _b = [];
                    _c.label = 8;
                case 8:
                    files = _b;
                    currentPosts = files.map(function (file) { return slugize(parse(file).name, { transform: 1 }); });
                    _c.label = 9;
                case 9:
                    if (!(posts.length >= 1)) return [3 /*break*/, 16];
                    _i = 0, posts_1 = posts;
                    _c.label = 10;
                case 10:
                    if (!(_i < posts_1.length)) return [3 /*break*/, 15];
                    post = posts_1[_i];
                    if (currentPosts.length && skipduplicate) {
                        if (currentPosts.includes(slugize(post.title, { transform: 1 }))) {
                            skipNum++;
                            return [3 /*break*/, 14];
                        }
                    }
                    _c.label = 11;
                case 11:
                    _c.trys.push([11, 13, , 14]);
                    return [4 /*yield*/, Post.create(post)];
                case 12:
                    _c.sent();
                    return [3 /*break*/, 14];
                case 13:
                    err_2 = _c.sent();
                    log.error(err_2);
                    errNum++;
                    return [3 /*break*/, 14];
                case 14:
                    _i++;
                    return [3 /*break*/, 10];
                case 15:
                    postsNum = posts.length - errNum - skipNum;
                    if (untitledPostCounter) {
                        log.warn('%d posts did not have titles and were prefixed with "Untitled Post".', untitledPostCounter);
                    }
                    if (postsNum)
                        log.info('%d posts migrated.', postsNum);
                    if (errNum)
                        log.error('%d posts failed to migrate.', errNum);
                    if (skipNum)
                        log.info('%d posts skipped.', skipNum);
                    _c.label = 16;
                case 16: return [2 /*return*/];
            }
        });
    });
};
exports.migrator = migrator;
//# sourceMappingURL=migrator.js.map